
#include "SevSeg.h"
SevSeg sevseg; //Die Klasse des 7-Segment-Displays instanziieren
byte numDigits = 4; //Anzahl der Digit im Display 
byte digitPins[] = {2,3,4,5}; //gemeinsame Anschlüsse der Digits von links nach rechts
byte segmentPins[] = {6, 7, 8, 9, 10, 11, 12, 13}; // Segment Anschlüsse von a nach g und DP

unsigned long timer;   //Variable für Millisekunden
int ZehntelSekunden;
int Start_Stop = 14;  //Pin an dem der Start/Stop- Taster angeschlossen ist (analog 0)
int Null_setzen = 15; //Pin an dem der Null- Setztaster angeschlossen ist (analog 1)
bool Run = false;    //Variable, die anzeigt dass die Stoppuhr läuft
bool pressed = false;//Variable, die anzeigt ob der Taster gedrückt wurde


bool debounce(int pin, bool idle_state, int debouncetime) {
long time = millis();
int reading = digitalRead(pin);
int state = idle_state;

  if (reading != idle_state && pressed == false) {
    while (millis() - time <= debouncetime) { 
    }
  }
  while (reading != idle_state) {
    reading = digitalRead(pin);
    if (pressed == false) pressed = true;
    //state = ~idle_state;
    if (idle_state == HIGH) state = LOW; 
    else state = HIGH; 
  };
  return state;
}

void setup() {
  sevseg.begin(COMMON_CATHODE, numDigits, digitPins, segmentPins); //Initialisierung des Displays
  sevseg.setBrightness(60); //Möglichkeit des Dimmens - bis jetzt keine Änderung festzustellen
  pinMode(Start_Stop, INPUT);
  pinMode(Null_setzen, INPUT);
  ZehntelSekunden = 0;
  timer = millis();
}

void loop() {
  if (debounce(Start_Stop,HIGH,1) == 0) {
    if (Run == false) {
      Run = true;
      timer = millis();
      if (pressed == true) {pressed = false;}
    }
    else {
      Run = false;
    }
  };
  
  if (debounce(Null_setzen,HIGH,10) == 0) {
    if (Run == false) {
      ZehntelSekunden = 0;
      timer = millis();
    }
  };
  
  if ((millis() >= timer) && (Run == true)) {
    ZehntelSekunden++; // 100 Millisekunden sind eine Zehntelsekunde
    timer += 100; 
    if (ZehntelSekunden == 10000) { // Den Zähler nach 1000 Sekunden zurücksetzen
      ZehntelSekunden=0;
    }
    sevseg.setNumber(ZehntelSekunden, 1); //Zehntelsekunden darstellen mit dem Dezimalpunkt an der dritten Stelle
  }

  sevseg.setNumber(ZehntelSekunden, 1);
  sevseg.refreshDisplay(); //Immer das Display refreshen
}

